import QtQuick 2.1
import QtQuick.Layouts 1.11

import org.kde.kirigami 2.4 as Kirigami
import QtQuick.Controls 2.11 as QQC2

Item {
    id: root
    clip: true

    //////// API
    property alias count: countRow.count
    property var modelrange
    property alias title: title.text

    property bool userConfiguring: false

    property int fontSize: 14
    property int _margin: Kirigami.Units.gridUnit

    opacity: enabled ? 1.0 : 0.5

    Connections {
        target: root
    }

    Behavior on width {
        SequentialAnimation {
            PauseAnimation {
                duration: 250
            }
            NumberAnimation {
                //duration: PlasmaCore.Units.longDuration
                duration: 250
                easing.type: Easing.InOutQuad
            }
        }
    }

    //imagePath: "widgets/picker"
    implicitWidth: countRow.width + root._margin
    implicitHeight: countRow.height + root._margin * 2

    Timer {
        id: userConfiguringTimer
        repeat: false
        interval: 100
        running: false
        onTriggered: {
            root.count = countRow.count
            userConfiguring = false
        }
    }

    QQC2.Label {
        id: title
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        horizontalAlignment: Text.AlignHCenter
        padding: Kirigami.Units.smallSpacing
    }

    Row
    {
        id: countRow
        anchors.top: title.bottom
        anchors.horizontalCenter: parent.horizontalCenter
        spacing: Kirigami.Units.gridUnit

        x: root._margin
        y: root._margin

        property int count

        Kirigami.Separator {
            anchors {
                top: parent.top
                bottom: parent.bottom
            }
        }


        Digit {
            id: countDigit
            model: modelrange
            currentData: count

            onSelectedIndexChanged: {
                if (selectedIndex > -1 && selectedData > -1) {
                    count = selectedData;
                }
            }
        }

        Kirigami.Separator {
            anchors {
                top: parent.top
                bottom: parent.bottom
            }
        }
    }
}
